/* SCSI device selection */

#define DEV_FLOPPY	0xa0
#define DEV_CDDVD	0xb0

/* image file mode selection */

#define DEV_NONE	0x00
#define DEV_RO		0x01
#define DEV_RW		0x02

/* register handling values */

#define REGS_STATE		0
#define REGS_ENABLE_NOW		1
#define REGS_ENABLE_REBOOT	2
#define REGS_DISABLE_NOW	3
#define REGS_DISABLE_GRACEFUL	4
#define REGS_DISABLE_REBOOT	5

#define REGS_UNKNOWN		0
#define REGS_NONE		1
#define REGS_DISABLED		2
#define REGS_ENABLED		3
#define REGS_FAIL		4

/* no public access data */

struct iderctx;

/* prototypes */

extern int ider_engine(struct iderctx *ctx);
extern int ider_device(struct iderctx *ctx,int dev,int mode,int fd);
extern int ider_regs(struct iderctx *ctx,int mode);
extern struct iderctx *ider_init(int persist,int verbose,int debug,
	int rx_timeout,int tx_timeout,int heartbeat,int readtoc,
	int (*io)(void *parm,unsigned char *data,int len,int mode),
	int (*iowait)(void *parm,int msecs),
	void (*regstate)(void *parm,int state),void *parm);
extern int ider_start(struct iderctx *ctx,char *user,char *pass);
extern int ider_end(struct iderctx *ctx);
