#if defined(USE_OPENSSL)
#include <openssl/ssl.h>
#include <openssl/err.h>
#elif defined(USE_GNUTLS)
#include <gnutls/gnutls.h>
#endif

struct ctx
{
	int fd;
	int efd;
	int iodebug;
	char *cacert;
#if defined(USE_OPENSSL)
	SSL *ssl;
	SSL_CTX *ctx;
#elif defined(USE_GNUTLS)
	gnutls_session_t ssl;
	gnutls_certificate_credentials_t cred;
#endif
	void (*lock)(void *lck);
	void (*unlock)(void *lck);
	void *lck;
};

extern int iowait(void *parm,int msecs);
extern int io(void *parm,unsigned char *data,int len,int mode);
extern int doconnect(struct ctx *ctx,char *host,int v4flag);
extern void doclose(struct ctx *ctx);
